function [out1, out2, out3]=pifn(t,y, flag)
global r K0 K1   % input, controller parameters
% ODE for linear PI controller
if nargin < 3 flag=''; end
switch flag
case ''                                 % Return dy/dt = f(t,y).
   rr=y(1);x1=y(3);x2=y(4); 
   x1dot=-50*x1+50*r; % controller
   x2dot=x1;
   rrdot=K0*x1dot+K1*x2dot;
   rdot=0.0;
   
   out1=[rrdot; rdot; x1dot; x2dot];
   
case 'init'                             % Return init conditions etc.
   axes=findobj('Tag','Step Response Plot'); Xlm=get(axes,'XLim');
   out1 = [Xlm(1) Xlm(2)];
   out2 = [0.0 r 0.0 0.0];
   out3 = [];
end