function [out1,out2,out3]=plantinversefn(t,yy,flag)
global r epsd lambda  % input, controller parameters
% ODE for plant+inverse controller closed-loop system

if nargin < 3 flag=''; end
switch flag
case ''                                 % Return dy/dt = f(t,y).
   y=yy(1); rr=yy(2); w=yy(3); 
   
   rho=rr-10*y; 
   dG=1-tanh(rho).^2+0.01;
   edot=lambda*(r-y);
   
   % controller
   wdot= -(10+1/epsd)*dG*w-dG/epsd*edot; % controller w dynamics
   rrdot=(w+edot)/epsd;  % controller output
   
   %plant
   ydot=tanh(rho)+0.01*(rho); % plant
   
   out1=[ydot; rrdot; wdot];
   
case 'init'                             % Return init conditions etc.
   axes=findobj('Tag','Step Response Plot'); Xlm=get(axes,'XLim');
   out1 = [Xlm(1) Xlm(2)];
   out2 = [0.0 0.0 0.0];
   out3 = [];
end