function [out1,out2,out3]=plantpifn(t,yy,flag)
global r K0 K1   % input, controller parameters
% ODE for plant+linear PI controller closed-loop system

if nargin < 3 flag=''; end
switch flag
case ''                                 % Return dy/dt = f(t,y).
   y=yy(1); x1=yy(3); x2=yy(4);
   
   x1dot=-50*x1+50*(r-y); % controller
   x2dot=x1;
   rr=K0*x1+K1*x2;
   rrdot = K0*x1dot+K1*x2dot; % auxiliary state which is solved to get plant input
   y1dot=tanh(rr-10*y)+0.01*(rr-10*y); % plant
   
   out1=[y1dot; rrdot; x1dot; x2dot];
   
case 'init'                             % Return init conditions etc.
   axes=findobj('Tag','Step Response Plot'); Xlm=get(axes,'XLim');
   out1 = [Xlm(1) Xlm(2)];
   out2 = [0.0 0.0 0.0 0.0];
   out3 = [];
end