function [out1,out2,out3]=plantschedpifn(t,yy,flag)
global r K00 K10 K01 K11  % input, controller parameters
% ODE for plant+scheduled PI controller closed-loop system

if nargin < 3 flag=''; end
switch flag
case ''                                 % Return dy/dt = f(t,y).
   y=yy(1); rr=yy(2); w2=yy(3);
   
   rho=rr-10*y; 
   
   % gaussian weighting centred on origin 
   x=0.8*rho; weight=exp(-x.^2);
   weight1=(1-weight).^2; weight0=1-weight1;

   % blended controller
   K0=weight0*K00+weight1*K01; K1=weight0*K10+weight1*K11;
   w2dot=-50*w2+50*(r-y);
   rrdot=K0*w2dot+K1*w2;  % controller output
   
   %plant
   ydot=tanh(rho)+0.01*(rho); % plant
   
   out1=[ydot; rrdot; w2dot];
   
case 'init'                             % Return init conditions etc.
   axes=findobj('Tag','Step Response Plot'); Xlm=get(axes,'XLim');
   out1 = [Xlm(1) Xlm(2)];
   out2 = [0.0 0.0 0.0];
   out3 = [];
end